#!/usr/bin/python
SECURE="ssl"
NORMAL="pop"
GMAIL ="gmail"
verbose=False
header="MANO: MAil NOtifier"
subtitle="by Dario Varotto (dariosky@gmail.com)"
version="1.16"

test=False;
import cPickle, os, time, gzip, traceback, email, re, sys
import platform

def autoUpdate():
	from lib import autoupdater
	autoupdater.autoupdate("http://dariosky.it/mano.php",	r'<h2><a href="(.*)">versione: .*?</a></h2>')
	sys.exit(1)

def getSourcePath():
	"""Return the directory where the program is located given sys.argv[0]"""
	return os.path.dirname( os.path.realpath(sys.argv[0]) )+"/"

sourcepath=getSourcePath()
sys.path.append(sourcepath)
from lib import poplib
from lib import ansi

def createAccount(filename):
		""" Ask user some data to create a new account """
		messypath=smslength=mintowait=""
		newconf=""
		try:
			if not os.path.isfile(filename):
				header="#File di configurazione per MANO - Mail Notifier\n"
				print "Creo il file %s."%filename
				print "Iniziamo con alcune preferenze globali:"

				mintowait=raw_input(" ogni quanti minuti devo controllare la posta [15]? ")
				try: mintowait=int(mintowait)
				except: mintowait=15

				smslength=raw_input(" quanto deve essere la lunghezza massima degli SMS [100]? ")
				try:	smslength=int(smslength)
				except: smslength=100

				messypath=""
				while not os.path.isfile(messypath):
					messypath=raw_input(" devi darmi il percorso completo dove trovare messy.py: ")
				print
				print "Benissimo! Questo e' tutto per le impostazioni globali."
				print "Ricorda che puoi aggiungere altri account chiamando 'mano' con l'opzione -add"
				print

			else:
				header=""

			newconf=file(filename,"a")
			newconf.write( header )
			if messypath or smslength or mintowait:
				newconf.write("[global]\n")
				newconf.write("mintowait:%s\n"%mintowait)
				newconf.write("smslength:%s\n"%smslength)
				newconf.write("messypath:%s\n"%messypath)
				newconf.write("\n")

			accname=acctype=accserver=accuser=accpass=accdest=""
			print "Vediamo di creare un nuovo account:"
			print
			print " come vuoi chiamare il nuovo account?"
			print "  (inserisci un nome diverso per ogni account)"
			while not accname:
				accname=raw_input()

			while not ( acctype in ("POP","SSL","GMAIL") ):
				acctype=raw_input(" inserisci ora il tipo di server di posta tra POP, SSL, GMAIL: ").upper()

			if acctype!="GMAIL":
				print " inserisci ora il nome del server della posta in arrivo a cui collegarmi:"
				print "  per esempio: popmail.libero.it"
				while not accserver:
					accserver=raw_input()

			print " inserisci ora il nome utente del quale scaricare la posta:"
			if acctype!="GMAIL":
				print "  per esempio pippero@libero.it"
			else:
				print "  per esempio pippero@gmail.com"
			while not accuser:
				accuser=raw_input()

			print " inserisci la password dell'utente:"
			while not accpass:
				accpass=raw_input()

			print " infine inserisci il numero di telefono, o il contatto (se gia' nella rubrica di messy)"
			print "  a cui inviare i messaggi di notifica:"
			while not accdest:
				accdest=raw_input()

			print "FINITO ! Congratulazioni..."
			print "premi invio per cominciare a controllare la posta"
			raw_input()
			print

			newconf.write("[%s]\n"%accname)
			newconf.write("type: %s\n"%acctype)
			if acctype!="GMAIL":
				newconf.write("server: %s\n"%accserver)
			newconf.write("username: %s\n"%accuser)
			newconf.write("password: %s\n"%accpass)
			newconf.write("notifyto: %s\n"%accdest)

			newconf.write("\n")
			newconf.close()
		except KeyboardInterrupt:
			print "\nTe ne vai? Non era difficile!!!"
			sys.exit(0)


def importConfig(filename):
	import ConfigParser
	result=[]

	conf=ConfigParser.ConfigParser( )
	if not os.path.isfile(filename):
		print "Il file di configurazione non esiste, creiamone uno assieme:"
		createAccount(filename)

	conf.read(filename)
	if not conf.has_section("global"):
		conf.add_section("global")
	global MAXSMS, messypath, mintowait

	try:	MAXSMS=int(conf.get("global", "smslength"))
	except: MAXSMS=100

	try: messypath=conf.get("global", "messypath")
	except: messypath='/home/dariosky/Pro/Python/messy/messy.py'
	messypath=os.path.realpath(messypath)

	if not os.path.isfile(messypath):
		print "Non posso trovare messy in '%s'"%messypath
		sys.exit(1)
	#print "Messy lo trovo qui: '%s'"%messypath

	try: mintowait=int(conf.get("global", "mintowait"))
	except: mintowait=15

	for sec in conf.sections():
		if sec=="global": continue
		d=dict( conf.items(sec) ) #converte gli item in un dizionario
		result.append( d )
	return result

def loadKnown(filename) :
	""" Carica da file i file conosciuti per l'account
		Il file si chiamera' known-host-account.mak
		restituisce una lista di id """
	#print "Carico %s"%filename
	if os.path.isfile(filename):
		fusers=gzip.open(filename,"rb")
		knownmessages=cPickle.load(fusers)	#leggo i conosciuti
		fusers.close()
		#print "Caricati %s messaggi conosciuti"%len(knownmessages)
	else:
		knownmessages=[]
	return knownmessages

def saveKnown(filename,known) :
	""" Salva su file i conosciuti per l'account - vedi loadKnown """
	dirname=os.path.split(filename)[0]
	if not os.path.isdir( dirname ):
		os.mkdir (dirname,0770)

	fusers=gzip.open(knownfilename,"wb")
	cPickle.dump(known,fusers,2)	#aggiorno i knownmessages
	fusers.close()

def myMessageFromEmail (em):
	""" Given an email type object, extract something to dictionary and try to take text """
	global verbose
	if em==None: return
	headers={} #metto gli headers in dizionario, perdendo i doppi
	for h,v in em._headers:
		headers[h.lower()]=v #in minuscolo la chiave

	mexfrom=em.get("from", "") #[5:em.get("from").index("<")].strip()
	mexid=em.get("message-id","0")
	mexid=mexid.strip()
	
	mexsubj=em.get("subject")
	if mexsubj==None: mexsubj=""
	else: mexsubj=mexsubj.strip()


	mexbody=""

	bodyes=em.get_payload()	#ottengo il corpo, o la lista di corpi del messaggio

	if type(bodyes)==list:	#se e' una lista
		found=False
		if verbose: print "Ci sono %d bodyes"%len(bodyes)
		for x in range( len(bodyes) ):
			if verbose: print bodyes[x].get_content_type()
			if bodyes[x].get_content_type() == "text/plain":
				found=True;
				mexbody=bodyes[x].get_payload()
				mextype=bodyes[x].get_content_type()
		if not found:	#se non trovo text/plain scelgo il primo body
			if verbose: print "Scelgo il primo body"
			mexbody=bodyes[0].get_payload()
			mextype=bodyes[0].get_content_type()

	else:	#se e' un messaggio con un solo corpo
		if verbose: print "Un solo corpo"
		mexbody=bodyes
		mextype=em.get_content_type()

	return { "body":str(mexbody),
			 "subject":mexsubj,
			 "from":mexfrom,
			 "id":mexid,
			 "type":mextype }

class gmailNotify:
	def __init__(self, user, password):
		from lib import libgmail
		self.messages=[]

		ga = libgmail.GmailAccount(user, password)

		try:
			ga.login()
		except Exception, e:
			if not cron: print "Non sono riuscito a fare il login... prova ad aggiornare mano all'ultima versione"

		folder = ga.getMessagesByFolder('inbox')

		for thread in folder:
			#print thread.id, len(thread), thread.subject
			ms=[]	#creo una lista dei messaggi nel thread
			for msg in thread:
				ms.append(msg)
			#~ print "  ", msg.id, msg.number, msg.subject
			#~ print msg.source
			#~ print
			em=email.message_from_string(ms[-1].source.strip()) #e notifico l'ultimo
			self.messages.append( myMessageFromEmail( em) )

	def __iter__(self):
		for mex in self.messages:
			yield mex

	def __len__(self):
		return len(self.messages)


class popNotify:
	""" this class given a user, password, host and a poplib method connect to POP (or SSL) and return a iterable sequence of messages """
	def __init__(self, popmethod, host, user, password):
		self.messages=[] #questo e' il dizionario di messaggi (dizionari anch'essi)
		conn = popmethod(host)
		conn.user(user)
		conn.pass_(password)
		numMessages = len( conn.list()[1] ) #message, count, octet

		for i in range(numMessages):	#per ogni messaggio
			mexinlist=conn.retr(i+1)[1] #messagecommand, messaggio, octet
			em=email.message_from_string("\n".join(mexinlist) ) #creo email

			self.messages.append( myMessageFromEmail( em) )

		conn.quit()

	def __iter__(self):
		for mex in self.messages:
			yield mex

	def __len__(self):
		return len(self.messages)

def extractMailAddress(fromstr):
	""" Extract only the address part from a string like : Fromname <name@host.dom> """
	sr=re.search( "<(.*)@.*>", fromstr )	#return everything between < and @
	if sr and sr.groups() and sr.groups()[0]:
		return sr.groups()[0]
	return fromstr #I wasn't able to strip so I return the complete one

def stripTags(html):
	""" Given a HTML string destroy all tags """
	return re.sub("<.*?>","",html).strip()	#destroy anything between <>

def stripComment(html):
	""" Elimina la firma finale, che parte dall'ultimo "\n-- \n" """
	startCommento=html.rfind("\r\n-- \r\n")
	if startCommento==-1: startCommento=html.rfind("\r\n-- \r\n")

	if startCommento==-1:
		return html
	else:
		return html[:startCommento]

def shortSpaces(html):
	""" Abbrevio tutti gli spazi consecutivi lascandone uno solo """
	lastWasSpace=False;
	result=""
	for ch in html:
		if ch==" ":
			if lastWasSpace: continue
			lastWasSpace=True
		else:
			lastWasSpace=False
		result+=ch
	return result.strip()	#and remove trailing spaces too

def deleteQuote(body):
	""" Delete all rows starting with > """
	result=[]
	for line in body.splitlines():
		if line and line[0]!=">": result.append(line)
	return " ".join(result)

def showSintax():
	print ansi.RED+header+ansi.RESET
	print ansi.GREEN+subtitle+ansi.RESET+" - "+ansi.YELLOW+version+ansi.RESET
	print
	print "Usage: mano.py <options>"
	print
	print "Options:"
	print "%s %30s"%("--help","Show this help page")
	print "%s %30s"%("-a --add","Add a new mail account to check")
	print "%s %30s"%("-c --cron","For cron script check and close")
	print "%s %30s"%("-u --update","Update to the latest online version")
	print

if __name__ == "__main__":
	cron=False
	someMex=False

	import getopt
	(options,altro)=getopt.getopt(sys.argv[1:],"auc", ("add","update","cron","help") )
	for (opz,value) in options:
		if opz in ("--help",):
			showSintax()
			sys.exit(0)
		if opz in ("-a","--add"):
			createAccount(sourcepath+"config.ini")
		if opz in ("-u","--update"):
			autoUpdate()
		if opz in ("-c","--cron"): cron=True

	FirstRide=not cron  #se True non notifico
	mailtocheck=importConfig(sourcepath+"config.ini")

	while True:	#a oltranza
		if not cron: ansi.clear(); ansi.move(0,0);
		if not cron: print ansi.RED+header+ansi.RESET
		if not cron: print ansi.GREEN+subtitle+ansi.RESET+" - "+ansi.YELLOW+version+ansi.RESET

		if not cron: ansi.move(4,0)
		for account in mailtocheck: #per ogni host
			try:
				mode=account["type"].lower()
				if mode==NORMAL:
					popmethod=poplib.POP3
				elif mode==SECURE:
					popmethod = poplib.POP3_SSL

				user=account["username"]
				password=account["password"]
				mode=mode.lower()
				if mode in (NORMAL,SECURE):
					host=account["server"]
					if not cron: print "Mi collego a %s, con l'account %s"%(host,user)
					messageJar=popNotify(popmethod, host, user, password)
				elif mode==GMAIL:
					if not cron: print "Mi collego a gmail, con l'account %s"%user
					host="gmail.com"
					messageJar=gmailNotify(user,password)

				if messageJar:
					if not cron: print " ci sono",len(messageJar),"messaggi."

				knownfilename=sourcepath+"knownmail/known-%s-%s.mak"%(host,user)
				if len(messageJar): #carico i conosciuti se ho almeno un messaggio
					knownmessages=loadKnown(knownfilename)

				newKnownMessages=[] #tengo un altra lista con solo i messaggi conosciuti presenti in mailbox

				for mex in messageJar:	#per ogni messaggio

					mex["from"]=extractMailAddress(mex["from"])	#keep only email address

					if mex["type"] == "text/html":
						mex["body"]=stripTags(mex["body"]) #away damned tags!!

					mex["body"]=deleteQuote(mex["body"])	#elimina le righe con i quote
					mex["body"]=stripComment(mex["body"]) #elimina il commento finale
					mex["body"]=" ".join( mex["body"].split("\n") ) #messaggio appiattito
					mex["body"]=" ".join( mex["body"].split("\r") )
					mex["body"]=shortSpaces(mex["body"]) #riduce tutti i doppi spazi a uno solo


					#print "id : %s"% mex["id"]
					#print "from : %s"%mex["from"].__repr__()
					#print "subject : %s"%mex["subject"].__repr__()
					#print "body : %s" % mex["body"].__repr__()
					#print

					if knownmessages.count(mex["id"]): #non avvisare per messaggi gia' mandati
						if not cron: print " messaggio da %s gia' notificato"%mex["from"]
						newKnownMessages.append(mex["id"])
						continue
					newKnownMessages.append(mex["id"])

					sms= "Mex:"
					sms+=mex["from"]
					sms+="-"+mex["subject"][:20]+"-"
					sms+=mex["body"][:MAXSMS-len(sms)]	#al massimo MAXSMS caratteri
					if not cron: print " %s"%sms

					if not test:
						destname=account["notifyto"]
						sms=sms.replace('"',"\\\"")	#tolgo gli insediosi apici doppi
						if not FirstRide:
							(inp, out, err)=os.popen3('%s "%s" "%s"'%(messypath, destname, sms) ) #SEND SMS!
						someMex=True


				if newKnownMessages:
					saveKnown(knownfilename, newKnownMessages)

			except Exception, e:
				if not cron: print "C'e' stato qualche errore, ma non mi arrendo!"
				#print e
				#traceback.print_exc()
			if not cron: print

		if FirstRide and someMex:
			if not cron: print "Non notifico al primo giro ! :) Controllo la NUOVA posta!"
		FirstRide=False

		if not cron:
			print
			try:
				for minutes in range(mintowait):
					print "Aspetto %2d m ancora..."% (mintowait-minutes)
					ansi.moveUp(2)
					time.sleep(60)	#aspetta tot secondi

			except KeyboardInterrupt:
				print "Fine... Ciao ciao!"
				ansi.clear(); ansi.move(0,0)
				break
		else:
			break
